'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RelayEnvContextType = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classic = require('react-relay/classic');

var _classic2 = _interopRequireDefault(_classic);

var _queryFetchCache = require('./queryFetchCache');

var _queryFetchCache2 = _interopRequireDefault(_queryFetchCache);

var _mutate2 = require('../../mutate');

var _mutate3 = _interopRequireDefault(_mutate2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RelayEnvContextType = exports.RelayEnvContextType = _propTypes2.default.shape({
    env: _propTypes2.default.instanceOf(_classic2.default.Environment).isRequired,
    reset: _propTypes2.default.func.isRequired,
    initialRender: _propTypes2.default.bool.isRequired,
    addResetListener: _propTypes2.default.func.isRequired,
    removeResetListener: _propTypes2.default.func.isRequired,
    shouldForceFetch: _propTypes2.default.func.isRequired,
    onQuerySuccess: _propTypes2.default.func.isRequired,
    mutate: _propTypes2.default.func.isRequired
}).isRequired;

var RelayEnvProvider = function (_React$PureComponent) {
    _inherits(RelayEnvProvider, _React$PureComponent);

    function RelayEnvProvider() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, RelayEnvProvider);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RelayEnvProvider.__proto__ || Object.getPrototypeOf(RelayEnvProvider)).call.apply(_ref, [this].concat(args))), _this), _this._resetListeners = [], _this._queryFetchCache = new _queryFetchCache2.default(), _this.relayEnvContext = {
            // The Relay.Environment
            env: _this.props.initialEnv || _this.props.createEnv && _this.props.createEnv(),

            // Reset the Relay store and re-render all renderers
            reset: function reset() {
                if (_this.props.createEnv) {
                    _this.relayEnvContext.env = _this.props.createEnv();
                    // Notify RelayRenderer components that they should force update
                    _this._resetListeners.forEach(function (callback) {
                        callback();
                    });
                } else if (process.env.NODE_ENV !== "production") {
                    throw Error("createEnv not provided to RelayEnvProvider or relayEnvContext.reset called unexpectedly");
                }
            },

            // Are we in the initial render? Used in isomorphic rendering
            initialRender: true,

            // Renderers register to be notified of resets here
            addResetListener: function addResetListener(callback) {
                _this._resetListeners.push(callback);
            },
            removeResetListener: function removeResetListener(callback) {
                _this._resetListeners = _this._resetListeners.filter(function (other) {
                    return other !== callback;
                });
            },

            // Used to manage TTL
            shouldForceFetch: _this._queryFetchCache.shouldForceFetch,
            onQuerySuccess: _this._queryFetchCache.onQuerySuccess,

            // Mutation helper
            mutate: function mutate(config) {
                return (0, _mutate3.default)(_this.relayEnvContext.env, config);
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(RelayEnvProvider, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return { relayEnv: this.relayEnvContext };
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.relayEnvContext.initialRender = false;
        }
    }, {
        key: 'render',
        value: function render() {
            return _react.Children.only(this.props.children);
        }
    }]);

    return RelayEnvProvider;
}(_react2.default.PureComponent);

RelayEnvProvider.propTypes = {
    createEnv: _propTypes2.default.func,
    initialEnv: _propTypes2.default.instanceOf(_classic2.default.Environment),
    children: _propTypes2.default.element.isRequired
};
RelayEnvProvider.childContextTypes = { relayEnv: RelayEnvContextType };
exports.default = RelayEnvProvider;