"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MAX_TTL = 1000 * 60 * 60 * 24; // 24 hours

var QueryFetchCache = function () {
    function QueryFetchCache() {
        var _this = this;

        _classCallCheck(this, QueryFetchCache);

        this.cache = {};

        this.onQuerySuccess = function (queryConfig) {
            _this.garbageCollect();
            _this.cache[_this.getKey(queryConfig)] = Date.now();
        };

        this.shouldForceFetch = function (queryConfig, ttl) {
            if (process.env.NODE_ENV !== "production" && ttl > MAX_TTL) {
                throw Error("ttl " + ttl + " is longer than 24 hours - use a shorter TTL");
            }

            var key = _this.getKey(queryConfig);
            if (key in _this.cache) {
                return Date.now() - _this.cache[key] > ttl;
            }
            return true;
        };
    }

    _createClass(QueryFetchCache, [{
        key: "getKey",
        value: function getKey(_ref) {
            var name = _ref.name,
                params = _ref.params;

            return name + "|" + JSON.stringify(params);
        }
    }, {
        key: "garbageCollect",
        value: function garbageCollect() {
            var _this2 = this;

            var now = Date.now();
            Object.keys(this.cache).forEach(function (key) {
                if (now - _this2.cache[key] > MAX_TTL) {
                    delete _this2.cache[key];
                }
            });
        }
    }]);

    return QueryFetchCache;
}();

exports.default = QueryFetchCache;