'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
    return function (Component) {
        return (0, _utils.wraps)(Component, function (props) {
            var setVariables = function setVariables(variables) {
                return new Promise(function (resolve, reject) {
                    props.relay.setVariables(variables, callback.bind(null, resolve, reject));
                });
            };

            var forceFetch = function forceFetch(variables) {
                return new Promise(function (resolve, reject) {
                    props.relay.forceFetch(variables, callback.bind(null, resolve, reject));
                });
            };

            return _react2.default.createElement(Component, _extends({}, props, {
                setVariables: setVariables,
                forceFetch: forceFetch
            }));
        }, Component.displayName || Component.name || Component.constructor.name);
    };
};

function callback(resolve, reject, _ref) {
    var error = _ref.error,
        ready = _ref.ready,
        aborted = _ref.aborted;

    if (ready) {
        resolve();
    } else if (error || aborted) {
        reject();
    }
}