'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../../utils');

var _RelayEnvProvider = require('../RelayEnvProvider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (mutations) {
    return function (Component) {
        function Wrapper(props, context) {
            var mutationProps = Object.keys(mutations).reduce(function (sum, key) {
                sum[key] = mutations[key](context.relayEnv.mutate);
                return sum;
            }, {});
            return _react2.default.createElement(Component, _extends({}, props, mutationProps));
        }
        Wrapper.contextTypes = { relayEnv: _RelayEnvProvider.RelayEnvContextType };
        return (0, _utils.wraps)(Component, Wrapper, 'WithRelayMutations(' + (Component.displayName || Component.name || Component.constructor.name) + ')');
    };
};