'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classic = require('react-relay/classic');

var _classic2 = _interopRequireDefault(_classic);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../../utils');

var _deepEqual = require('deep-equal');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _index = require('../RelayEnvProvider/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (_ref) {
    var optionsQueryConfig = _ref.queryConfig,
        _ref$forceFetch = _ref.forceFetch,
        forceFetch = _ref$forceFetch === undefined ? false : _ref$forceFetch,
        ttl = _ref.ttl,
        _ref$isomorphic = _ref.isomorphic,
        isomorphic = _ref$isomorphic === undefined ? true : _ref$isomorphic;
    return function (Container) {
        var componentName = Container.displayName || Container.name || Container.constructor.name;

        var Wrapper = function (_React$PureComponent) {
            _inherits(Wrapper, _React$PureComponent);

            function Wrapper() {
                var _ref2;

                var _temp, _this, _ret;

                _classCallCheck(this, Wrapper);

                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                    args[_key] = arguments[_key];
                }

                return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call.apply(_ref2, [this].concat(args))), _this), _this.useTtl = true, _this.queryConfig = _this.getQueryConfig(_this.props), _this.onRelayEnvReset = function () {
                    return _this.forceUpdate();
                }, _this.error = null, _this.offline = false, _this.renderContainer = function (_ref3) {
                    var error = _ref3.error,
                        props = _ref3.props,
                        retry = _ref3.retry;

                    /* eslint-disable no-unused-vars */
                    var _this$props = _this.props,
                        forceFetch = _this$props.forceFetch,
                        ownProps = _objectWithoutProperties(_this$props, ['forceFetch']);
                    /* eslint-enable no-unused-vars */


                    var allProps = _extends({}, ownProps, {
                        error: error || _this.error,
                        retry: retry,
                        loading: false,
                        offline: _this.offline
                    });

                    if (props) {
                        _this.context.relayEnv.onQuerySuccess(_this.queryConfig);
                        allProps = _extends({}, allProps, {
                            error: null,
                            offline: false
                        }, props);
                        _this.error = null;
                        _this.offline = false;
                        return _react2.default.createElement(Container, allProps);
                    }

                    // Have to provide these props to the Container - even if they are null
                    Container.getFragmentNames().forEach(function (fragmentName) {
                        allProps[fragmentName] = null;
                    });

                    if (error) {
                        _this.error = error;
                        if (error.toString() === 'TypeError: Network request failed') {
                            _this.offline = true;
                            allProps.offline = true;
                        }
                    } else {
                        allProps.loading = true;
                    }
                    return _react2.default.createElement(Container, allProps);
                }, _temp), _possibleConstructorReturn(_this, _ret);
            }

            _createClass(Wrapper, [{
                key: 'componentDidMount',
                value: function componentDidMount() {
                    this.context.relayEnv.addResetListener(this.onRelayEnvReset);
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this.context.relayEnv.removeResetListener(this.onRelayEnvReset);
                }
            }, {
                key: 'componentWillUpdate',
                value: function componentWillUpdate(nextProps) {
                    var newQueryConfig = this.getQueryConfig(nextProps);
                    if (!(0, _deepEqual2.default)(newQueryConfig, this.queryConfig)) {
                        // only update the queryConfig if it has changed, otherwise Relay will run the query again
                        this.queryConfig = newQueryConfig;
                        this.useTtl = true;
                    }
                }
            }, {
                key: 'getQueryConfig',
                value: function getQueryConfig(props) {
                    if (typeof optionsQueryConfig === 'function') {
                        /* eslint-disable no-unused-vars */
                        var _forceFetch = props.forceFetch,
                            ownProps = _objectWithoutProperties(props, ['forceFetch']);
                        /* eslint-enable no-unused-vars */


                        return optionsQueryConfig(ownProps, Container);
                    }

                    var name = optionsQueryConfig.name,
                        queries = optionsQueryConfig.queries,
                        _optionsQueryConfig$p = optionsQueryConfig.params,
                        paramDefinitions = _optionsQueryConfig$p === undefined ? {} : _optionsQueryConfig$p;

                    // Get param values from props

                    var params = Object.keys(paramDefinitions).reduce(function (params, paramName) {
                        if (paramName in props) {
                            params[paramName] = props[paramName];
                        }
                        return params;
                    }, {});

                    return { name: name, queries: queries, params: params };
                }

                // Used to keep track of whether a previous request failed due to being offline or an error
                // Useful if you want to show a retry button with a spinner to
                // detect the difference between initial load and the retry

            }, {
                key: 'render',
                value: function render() {
                    var _context$relayEnv = this.context.relayEnv,
                        env = _context$relayEnv.env,
                        initialRender = _context$relayEnv.initialRender;


                    if (isomorphic && env.isIsomorphicRender && (env.isServer || initialRender)) {
                        // Isomorphic render
                        var readyState = env.isomorphicRunQueriesOrGetReadyState(Container, this.queryConfig);
                        if (readyState) {
                            // We have a server response
                            return _react2.default.createElement(_classic2.default.ReadyStateRenderer, {
                                Container: Container,
                                queryConfig: this.queryConfig,
                                environment: env,
                                render: this.renderContainer,
                                readyState: readyState
                            });
                        }

                        if (env.isServer) {
                            // We don't have a server response yet - no point rendering anything
                            return null;
                        }
                    }

                    var shouldForceFetch = false;
                    if (!env.isServer) {
                        shouldForceFetch = forceFetch || this.props.forceFetch;
                        if (!shouldForceFetch && ttl && this.useTtl) {
                            shouldForceFetch = this.context.relayEnv.shouldForceFetch(this.queryConfig, ttl);

                            // The TTL should only take effect on initial mount or if the query config changes - not
                            // every time the component is rendered
                            this.useTtl = false;
                        }
                    }

                    // We're in normal render mode
                    return _react2.default.createElement(_classic2.default.Renderer, {
                        forceFetch: shouldForceFetch,
                        Container: Container,
                        queryConfig: this.queryConfig,
                        environment: env,
                        render: this.renderContainer
                    });
                }
            }]);

            return Wrapper;
        }(_react2.default.PureComponent);

        Wrapper.contextTypes = { relayEnv: _index.RelayEnvContextType };
        Wrapper.defaultProps = {
            forceFetch: false
        };


        var queryConfigParams = typeof optionsQueryConfig !== 'function' && optionsQueryConfig.params;
        // If we know the queryConfig at this point, we can add proptypes to enforce isRequired
        if (queryConfigParams) {
            // Grab propTypes from the paramDefinitions - just PropTypes.any for now, but handles isRequired
            Wrapper.propTypes = Object.keys(queryConfigParams).reduce(function (propTypes, paramName) {
                propTypes[paramName] = queryConfigParams[paramName].required ? _propTypes2.default.any.isRequired : _propTypes2.default.any;
                return propTypes;
            }, {});
        }

        return (0, _utils.wraps)(Container, Wrapper, componentName ? 'WithRelayRenderer(' + componentName + ')' : 'WithRelayRenderer');
    };
};