'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classic = require('react-relay/classic');

var _classic2 = _interopRequireDefault(_classic);

var _querySetMap = require('./querySetMap');

var _querySetMap2 = _interopRequireDefault(_querySetMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseEnvironment = function (_Relay$Environment) {
    _inherits(BaseEnvironment, _Relay$Environment);

    function BaseEnvironment() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, BaseEnvironment);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BaseEnvironment.__proto__ || Object.getPrototypeOf(BaseEnvironment)).call.apply(_ref, [this].concat(args))), _this), _this.isomorphicQueriesMap = new _querySetMap2.default(), _this.isIsomorphicRender = false, _this.isomorphicRunQuery = function (querySet) {
            var promise = new Promise(function (resolve) {
                // Tell Relay that we need data for this query - on the server it will perform the query, on the
                // client it will find the cached results.
                _this.isomorphicFetchQuerySet(querySet, function (readyState) {
                    if (readyState.error || readyState.aborted || readyState.done) {
                        var pendingQuery = _this.isomorphicQueriesMap.get(querySet);
                        if (pendingQuery) {
                            // Store the readyState associated with the querySet so we can get it on render
                            pendingQuery.readyState = readyState;
                            resolve();
                        }
                    }
                });
            });
            _this.isomorphicQueriesMap.set(querySet, { promise: promise, result: {} });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(BaseEnvironment, [{
        key: 'isomorphicRunQueriesOrGetReadyState',
        value: function isomorphicRunQueriesOrGetReadyState(Container, queryConfig) {
            var querySet = _classic2.default.getQueries(Container, queryConfig);
            var pendingQuery = this.isomorphicQueriesMap.get(querySet);

            // querySet fetch finished, return the readyState
            if (pendingQuery && pendingQuery.readyState) {
                // We should be here in the second server render and the first client render
                return pendingQuery.readyState;
            }

            // We haven't seen this querySet before
            if (!pendingQuery && this.isServer) {
                this.isomorphicRunQuery(querySet);
            }

            return null;
        }
    }, {
        key: 'isomorphicFetchQuerySet',
        value: function isomorphicFetchQuerySet(querySet, onReadyStateChange) {
            this.primeCache(querySet, onReadyStateChange);
        }
    }, {
        key: 'isomorphicQueriesPromise',
        get: function get() {
            return Promise.all(this.isomorphicQueriesMap.values().map(function (_ref2) {
                var promise = _ref2.promise;
                return promise;
            }));
        }
    }]);

    return BaseEnvironment;
}(_classic2.default.Environment);

exports.default = BaseEnvironment;