"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QuerySetMap = function () {
    function QuerySetMap() {
        _classCallCheck(this, QuerySetMap);

        this._keys = [];
        this._values = [];
    }
    /*
    Map where the keys are querySet objects
    */


    _createClass(QuerySetMap, [{
        key: "set",
        value: function set(k, v) {
            var index = this.indexOf(k);
            if (index > -1) {
                this._values[index] = v;
            } else {
                this._keys.push(k);
                this._values.push(v);
            }
        }
    }, {
        key: "get",
        value: function get(k) {
            var index = this.indexOf(k);
            if (index > -1) {
                return this._values[index];
            }
        }
    }, {
        key: "indexOf",
        value: function indexOf(k) {
            for (var index = 0; index < this._keys.length; index++) {
                if (this.keyEquals(k, this._keys[index])) {
                    return index;
                }
            }
            return -1;
        }
    }, {
        key: "keyEquals",
        value: function keyEquals(a, b) {
            /*
            Checks that the two querysets (objects {[queryName]: query}) match by checking their queryNames and using the
            "equals" method of each query
            */
            var aNames = Object.keys(a),
                bNames = Object.keys(b);

            if (aNames.length !== bNames.length) {
                return false;
            }

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = aNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var _name = _step.value;

                    if (!b[_name] || !b[_name].equals(a[_name])) {
                        return false;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return true;
        }
    }, {
        key: "keys",
        value: function keys() {
            return [].concat(_toConsumableArray(this._keys));
        }
    }, {
        key: "values",
        value: function values() {
            return [].concat(_toConsumableArray(this._values));
        }
    }, {
        key: "size",
        get: function get() {
            return this._keys.length;
        }
    }]);

    return QuerySetMap;
}();

exports.default = QuerySetMap;