'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _toGraphQL = require('react-relay/lib/toGraphQL');

var _toGraphQL2 = _interopRequireDefault(_toGraphQL);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _server3 = require('../networkLayer/server');

var _server4 = _interopRequireDefault(_server3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MAX_RECURSIONS = 10;

var ServerEnvironment = function (_BaseEnvironment) {
    _inherits(ServerEnvironment, _BaseEnvironment);

    function ServerEnvironment(fetchQuery) {
        _classCallCheck(this, ServerEnvironment);

        var _this = _possibleConstructorReturn(this, (ServerEnvironment.__proto__ || Object.getPrototypeOf(ServerEnvironment)).call(this));

        _this.isIsomorphicRender = true;
        _this.isServer = true;

        _this.isomorphicNetworkLayer = new _server4.default(fetchQuery);
        _this.injectNetworkLayer(_this.isomorphicNetworkLayer);
        return _this;
    }

    _createClass(ServerEnvironment, [{
        key: 'isomorphicFetchQuerySet',
        value: function isomorphicFetchQuerySet(querySet, onReadyStateChange) {
            // As new queries are found recursively some results will be in the cache. This means that the query is not
            // sent through the network layer so we can't associate a result with the query. We use forceFetch here so that
            // all queries go through the network layer
            this.forceFetch(querySet, onReadyStateChange);
        }
    }, {
        key: 'isomorphicGetData',
        value: function isomorphicGetData(element) {
            var maxRecursions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : MAX_RECURSIONS;

            return _isomorphicGetData(this, element, maxRecursions, null);
        }
    }, {
        key: 'isomorphicClientData',
        get: function get() {
            var _this2 = this;

            return this.isomorphicQueriesMap.keys().map(function (querySet) {
                // Connect queries with their results
                var clientData = {};
                Object.keys(querySet).forEach(function (queryName) {
                    var query = querySet[queryName];
                    if (_this2.isomorphicNetworkLayer.queryResults[query.getID()]) {
                        clientData[queryName] = {
                            query: _toGraphQL2.default.Query(query),
                            data: _this2.isomorphicNetworkLayer.queryResults[query.getID()]
                        };
                    }
                });
                return clientData;
            }).filter(function (querySetResult) {
                return Object.keys(querySetResult).length > 0;
            }); // Don't include empty/failed results
        }
    }]);

    return ServerEnvironment;
}(_base2.default);

exports.default = ServerEnvironment;


function _isomorphicGetData(env, element, maxRecursions, prevQueryCount) {
    // Keep rendering until maxRecursions or the query count doesn't change
    var markup = _server2.default.renderToString(element);
    if (maxRecursions === 0 || prevQueryCount === env.isomorphicQueriesMap.size) {
        return Promise.resolve(markup);
    }
    prevQueryCount = env.isomorphicQueriesMap.size;
    return env.isomorphicQueriesPromise.then(function () {
        return _isomorphicGetData(env, element, maxRecursions - 1, prevQueryCount);
    });
}