'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = mutate;

var _classic = require('react-relay/classic');

var _classic2 = _interopRequireDefault(_classic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mutate(env, config) {
    var query = config.query,
        variables = config.variables,
        _config$files = config.files,
        files = _config$files === undefined ? null : _config$files,
        optimisticResponse = config.optimisticResponse,
        _config$configs = config.configs,
        configs = _config$configs === undefined ? [] : _config$configs;


    var mutation;
    var promise = new Promise(function (resolve, reject) {
        mutation = new _classic2.default.GraphQLMutation(query, variables, files, env, {
            onSuccess: resolve,
            onFailure: function onFailure(transaction) {
                return reject(transaction.getError());
            }
        });
        if (optimisticResponse) {
            mutation.applyOptimistic(query, optimisticResponse, configs);
        }
        mutation.commit(configs);
    });

    var getPromiseRequest = function getPromiseRequest() {
        return env._requests.get(mutation._transaction.id);
    };

    promise = promise; // I give up

    promise.abort = function () {
        var request = getPromiseRequest(promise);
        if (request) {
            request.abort();
        }
    };
    promise.onUploadProgress = function (cb) {
        var request = getPromiseRequest(promise);
        if (request) {
            request.onUploadProgress(cb);
        }
        return promise; // To allow for method chaining
    };
    return promise;
}