'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classic = require('react-relay/classic');

var _classic2 = _interopRequireDefault(_classic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// A simple network layer that calls the passed in function to run a query and collects results
var ServerNetworkLayer = function () {
    function ServerNetworkLayer(fetchQuery) {
        var _this = this;

        _classCallCheck(this, ServerNetworkLayer);

        this.queryResults = {};

        this._sendQuery = function (queryRequest) {
            return new Promise(function (resolve, reject) {
                _this._fetchQuery({
                    query: queryRequest.getQueryString(),
                    variables: queryRequest.getVariables()
                }).then(function (response) {
                    var data = response.data;

                    if ('errors' in response || !data) {
                        var queryName = queryRequest.getQuery().getName();
                        var errorMsg = 'Server Error (' + queryName + ')';
                        try {
                            errorMsg += ' ' + JSON.stringify(response.errors);
                        } catch (err) {} // eslint-disable-line no-empty
                        var _error = new Error(errorMsg);
                        queryRequest.reject(_error);
                        reject(_error);
                    } else {
                        queryRequest.resolve({ response: data });
                        resolve(data);
                        _this.queryResults[queryRequest.getID()] = data;
                    }
                });
            });
        };

        this._fetchQuery = fetchQuery;
    }

    _createClass(ServerNetworkLayer, [{
        key: 'supports',
        value: function supports() {}
    }, {
        key: 'sendQueries',
        value: function sendQueries(queryRequests) {
            return Promise.all(queryRequests.map(this._sendQuery));
        }
    }]);

    return ServerNetworkLayer;
}();

exports.default = ServerNetworkLayer;