'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.namedQuery = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.wraps = wraps;
exports.splitQuery = splitQuery;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classic = require('react-relay/classic');

var _classic2 = _interopRequireDefault(_classic);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function wraps(Component, Wrapper, displayName) {
    Wrapper.WrappedComponent = Component;
    if (displayName) {
        Wrapper.displayName = displayName;
    }
    (0, _hoistNonReactStatics2.default)(Wrapper, Component, { WrappedComponent: true });
    return Wrapper;
}

var nextFragmentId = 1;
/*
Converting the output of:

Relay.QL`
    query {
        node(id: $id) {
            myField
        }
    }
`

to:

{
    routeQuery: Relay.QL`
        query {
            node(id: $id)
        }
    `,
    fragment: Relay.QL`
        fragment on Node {
            myField
        }
    `
}

This was created by examining the output of Relay.QL so there's a relatively high chance it only works by luck
*/
function splitQuery(query) {
    var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Index';

    var routeQuery = _extends({}, query, {
        name: name,
        children: query.children.filter(function (_ref) {
            var metadata = _ref.metadata;
            return metadata && (metadata.isGenerated || metadata.isRequisite);
        }).map(function (_ref2) {
            var metadata = _ref2.metadata,
                child = _objectWithoutProperties(_ref2, ['metadata']);

            return _extends({ metadata: _extends({}, metadata, { isGenerated: true }) }, child);
        })
    });
    var fragment = {
        id: nextFragmentId++ + '::relayhelperid', // assuming this ID can be made up like this
        kind: 'Fragment',
        type: query.type,
        metadata: {},
        name: name + '_Fragment',
        children: query.children
    };
    if (query.metadata.isAbstract) {
        fragment.metadata.isAbstract = true;
    }
    return { routeQuery: routeQuery, fragment: fragment };
}

var namedQuery = exports.namedQuery = function namedQuery(name, queryFactory) {
    return function () {
        var query = queryFactory.apply(undefined, arguments);
        query.name = name;
        return query;
    };
};